#ifndef FrameCPP__COMMON__PTR_STRUCT_BASE_HH
#define FrameCPP__COMMON__PTR_STRUCT_BASE_HH

namespace FrameCPP
{
  namespace Common
  {
    struct PTR_STRUCT_BASE
      : public FrameSpec::Object
    {
      typedef INT_2U class_type;
      typedef INT_4U instance_type;

      PTR_STRUCT_BASE( );
      ~PTR_STRUCT_BASE( );

      static std::string Desc( const std::string& Type );

      virtual class_type Class( ) const = 0;

      virtual void Class( class_type Class ) = 0;

      virtual instance_type Instance( ) const = 0;

      virtual void Instance( instance_type Instance ) = 0;

      virtual PTR_STRUCT_BASE* Clone( ) const = 0;

      bool IsNULL( ) const;
    };

    inline bool PTR_STRUCT_BASE::
    IsNULL( ) const
    {
      return ( ( Class( ) == 0 ) && ( Instance( ) == 0 ) );
    }

    inline std::string PTR_STRUCT_BASE::
    Desc( const std::string& Type )
    {
      std::string	ret("PTR_STRUCT(");

      ret += Type;
      ret += " *)";
      return ret;
    }
  } // namespace - Common
} // namespace - FrameCPP

#endif /* FrameCPP__COMMON__PTR_STRUCT_BASE_HH */
